## gromacs 2026~rc

=== docs/CMakeLists.txt ===
#
# This file is part of the GROMACS molecular simulation package.
#
# Copyright 2014- The GROMACS Authors
# and the project initiators Erik Lindahl, Berk Hess and David van der Spoel.
# Consult the AUTHORS/COPYING files and https://www.gromacs.org for details.
#
# GROMACS is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# GROMACS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with GROMACS; if not, see
# https://www.gnu.org/licenses, or write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
#
# If you want to redistribute modifications to GROMACS, please
# consider that scientific software is very special. Version
# control is crucial - bugs must be traceable. We will be happy to
# consider code for inclusion in the official distribution, but
# derived work must not be called official GROMACS. Details are found
# in the README & COPYING files - if they are missing, get the
# official version at https://www.gromacs.org.
#
# To help us fund GROMACS development, we humbly ask that you cite
# the research papers on the package. Check out https://www.gromacs.org.

# This directory provides a unified place for building all kinds of
# GROMACS documentation. This includes some "static" content (Doxygen
# code documentation, reference manual, install guide, old online HTML
# images), and content generated from the gmx program for the various
# tools (man and HTML pages). It also provides the "webpage" target,
# that combines all of the above (except man pages in man format) into
# a form suitable for automated deployment to the GROMACS website. It
# also provides the INSTALL file for the tarball.
#
# The webpage is mostly built by Sphinx.  Variable values for Sphinx
# substitutions are configured by CMake (for things like version numbers),
# using gmx_configure_version_file().  This happens during build time instead
# of configure time, because 1) some of the version variables are only
# available during build time, and 2) we don't want to do all the Sphinx setup
# during configuration to save some time when not building the content.
# All of the generated values get put into conf.py (generated from
# conf.cmakein.py).

set(SOURCE_MD5SUM "unknown" CACHE STRING
    "MD5 sum of the source tarball, normally used only for the pre-release webpage build")
# REGRESSIONTEST_MD5SUM is set in cmake/gmxVersionInfo.cmake because it is used also in tests/CMakeLists.txt
mark_as_advanced(SOURCE_MD5SUM)

set(EXPECTED_DOXYGEN_VERSION 1.8.5)

set(EXPECTED_SPHINX_VERSION 4.0.0)

# By default, suppress output after first configuration.
if(SPHINX_ALREADY_SEARCHED)
    set(Sphinx_FIND_QUIETLY ON)
endif()
find_package(Sphinx ${EXPECTED_SPHINX_VERSION} COMPONENTS pygments)
set(SPHINX_ALREADY_SEARCHED TRUE CACHE BOOL "True if a search for Sphinx has already been done")
mark_as_advanced(SPHINX_ALREADY_SEARCHED)

# Even if we aren't going to make the full webpage, set up to put all
# the documentation output in the same place, for convenience
set(HTML_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/html")
file(MAKE_DIRECTORY ${HTML_OUTPUT_DIR})

# Prepare directories for pdf/tex output
set(TEX_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/manual")
set(SPHINX_LATEX_FILE "${TEX_OUTPUT_DIR}/gromacs.tex")
file(MAKE_DIRECTORY ${TEX_OUTPUT_DIR})

# The directory from which man pages will be installed; if it remains
# empty, they will be silently skipped.
set(MAN_PAGE_DIR)
if (SOURCE_IS_SOURCE_DISTRIBUTION)
    # When building from the tarball, install the bundled man pages
    # (unless overridden).
    set(MAN_PAGE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
endif()

add_subdirectory(doxygen)

option(GMX_BUILD_MANUAL "Whether to try to configure to build the PDF manual" OFF)
mark_as_advanced(GMX_BUILD_MANUAL)
gmx_add_cache_dependency(GMX_BUILD_MANUAL BOOL GMX_DEVELOPER_BUILD ON)

set(MANUAL_BUILD_IS_POSSIBLE ON)
set(MANUAL_BUILD_NOT_POSSIBLE_REASON)
set(NO_IMAGE_CONVERT_REASON)
if (NOT GMX_BUILD_MANUAL)
    # Make sure we only do detection of manual-building dependencies
    # when the user opted in for that.
    set(MANUAL_BUILD_IS_POSSIBLE OFF)
    set(MANUAL_BUILD_NOT_POSSIBLE_REASON "GMX_BUILD_MANUAL is not ON")
elseif (BUILD_IS_INSOURCE)
    # UseLATEX.cmake does not work with an in-source build
    set(MANUAL_BUILD_IS_POSSIBLE OFF)
    set(MANUAL_BUILD_NOT_POSSIBLE_REASON "the build is in-source")
else()
    include(manual/UseLATEX.cmake)
    if(NOT SPHINX_FOUND)
        set(MANUAL_BUILD_IS_POSSIBLE OFF)
        set(MANUAL_BUILD_NOT_POSSIBLE_REASON "Sphinx has not been found and is needed to create the LaTex input files")
    elseif(NOT PDFLATEX_COMPILER)
        set(MANUAL_BUILD_IS_POSSIBLE OFF)
        set(MANUAL_BUILD_NOT_POSSIBLE_REASON "pdflatex is not available")
    elseif(NOT IMAGE_CONVERT_POSSIBLE)
        set(MANUAL_BUILD_IS_POSSIBLE OFF)
        set(MANUAL_BUILD_NOT_POSSIBLE_REASON "a working form of ImageMagick convert is not available")
        set(NO_IMAGE_CONVERT_REASON "Can not convert files for online or pdf manual")
        # TODO Later, identify other dependencies like bibtex,
        # make_index, date, some graphics conversion program,
        # etc. Perhaps patch UseLATEX.cmake and contribute upstream.
    endif()

endif()

if (SPHINX_FOUND)
    # We need to have all the Sphinx input files in a single directory, and
    # since some of them are generated, we copy everything into the build tree,
    # to this directory.
    set(SPHINX_INPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/sphinx-input)
    set(SPHINX_EXTENSION_PATH ${CMAKE_CURRENT_SOURCE_DIR})
    # As the manual build now depends also on Sphinx, the inclusion path needs
    # to be set after we know the basic information for Sphinx.
    add_subdirectory(manual)
    if (SOURCE_MD5SUM STREQUAL "unknown")
        # But for testing the webpage build (e.g. from the repo) we
        # need a default value.
        set(REGRESSIONTEST_MD5SUM_STRING "unknown")
    else()
        # The real build of the webpage happens from the tarball, and
        # this should be set to the matching MD5 sum.
        set(REGRESSIONTEST_MD5SUM_STRING "${REGRESSIONTEST_MD5SUM}")
    endif()
    # The reference manual still contains the individual sections from the
    # LaTeX document, with the files below grouped and annotated by chapter.
    set(REFERENCEMANUAL_SPHINX_FILES_GENERAL
        # Main index file, preface and introduction.
        reference-manual/index.rst
        reference-manual/preface.rst
        reference-manual/introduction.rst
        # Definitions and Units chapter
        reference-manual/definitions.rst
        # Topologies chapter
        reference-manual/topologies/topologies.rst
        reference-manual/topologies/particle-type.rst
        reference-manual/topologies/parameter-files.rst
        reference-manual/topologies/molecule-definition.rst
        reference-manual/topologies/constraint-algorithm-section.rst
        reference-manual/topologies/pdb2gmx-input-files.rst
        reference-manual/topologies/topology-file-formats.rst
        reference-manual/topologies/force-field-organization.rst
        # File formats chapter
        reference-manual/file-formats.rst
        # Run parameters and programs chapter
        reference-manual/run-parameters.rst
        # Implementation details chapter
        reference-manual/details.rst
        # Averages and fluctations chapter
        reference-manual/averages.rst
        # References
        reference-manual/references.rst
        # PNG formated plot files that don't need to be converted into PNG
        # for the web page.
        reference-manual/plots/GMX_logos/gmx_falcon_blue.png
        reference-manual/plots/plotje.png
        reference-manual/plots/xvgr.png
        )
    set(REFERENCEMANUAL_SPHINX_FILES_WITH_IMAGES
        # Algorithms chapter
        reference-manual/algorithms/algorithms.rst
        reference-manual/algorithms/periodic-boundary-conditions.rst
        reference-manual/algorithms/group-concept.rst
        reference-manual/algorithms/molecular-dynamics.rst
        reference-manual/algorithms/shell-molecular-dynamics.rst
        reference-manual/algorithms/constraint-algorithms.rst
        reference-manual/algorithms/simulated-annealing.rst
        reference-manual/algorithms/stochastic-dynamics.rst
        reference-manual/algorithms/brownian-dynamics.rst
        reference-manual/algorithms/energy-minimization.rst
        reference-manual/algorithms/normal-mode-analysis.rst
        reference-manual/algorithms/free-energy-calculations.rst
        reference-manual/algorithms/replica-exchange.rst
        reference-manual/algorithms/essential-dynamics.rst
        reference-manual/algorithms/expanded-ensemble.rst
        reference-manual/algorithms/parallelization-domain-decomp.rst
        # Interaction functions and force fields chapter
        reference-manual/functions/functions.rst
        reference-manual/functions/bonded-interactions.rst
        reference-manual/functions/force-field.rst
        reference-manual/functions/free-energy-interactions.rst
        reference-manual/functions/interaction-methods.rst
        reference-manual/functions/long-range-electrostatics.rst
        reference-manual/functions/long-range-vdw.rst
        reference-manual/functions/nonbonded-interactions.rst
        reference-manual/functions/polarization.rst
        reference-manual/functions/restraints.rst
        # Special topics chapter
        reference-manual/special/special.rst
        reference-manual/special/free-energy-implementation.rst
        reference-manual/special/pulling.rst
        reference-manual/special/awh.rst
        reference-manual/special/enforced-rotation.rst
        reference-manual/special/electric-fields.rst
        reference-manual/special/comp-electrophys.rst
        reference-manual/special/free-energy-pmf.rst
        reference-manual/special/remove-fast-dgf.rst
        reference-manual/special/viscosity-calculation.rst
        reference-manual/special/shearing.rst
        reference-manual/special/tabulated-interaction-functions.rst
        reference-manual/special/qmmm.rst
        reference-manual/special/vmd-imd.rst
        reference-manual/special/membrane-embedding.rst
        reference-manual/special/mimic-qmmm.rst
        reference-manual/special/density-guided-simulation.rst
        reference-manual/special/colvars.rst
        reference-manual/special/plumed.rst
        reference-manual/special/nnpot.rst
        reference-manual/special/fmm.rst
        # Analysis chapter
        reference-manual/analysis/analysis.rst
        reference-manual/analysis/using-groups.rst
        reference-manual/analysis/looking-at-trajectory.rst
        reference-manual/analysis/general-properties.rst
        reference-manual/analysis/radial-distribution-function.rst
        reference-manual/analysis/correlation-function.rst
        reference-manual/analysis/curve-fitting.rst
        reference-manual/analysis/mean-square-displacement.rst
        reference-manual/analysis/bond-angle-dihedral.rst
        reference-manual/analysis/radius-of-gyration.rst
        reference-manual/analysis/rmsd.rst
        reference-manual/analysis/covariance-analysis.rst
        reference-manual/analysis/dihedral-pca.rst
        reference-manual/analysis/hydrogen-bonds.rst
        reference-manual/analysis/protein-related.rst
        reference-manual/analysis/interface-related.rst)
    # The image files have also been ordered by the respective

=== cmake/AdaptiveCppTest/CMakeLists.txt ===
#
# This file is part of the GROMACS molecular simulation package.
#
# Copyright 2021- The GROMACS Authors
# and the project initiators Erik Lindahl, Berk Hess and David van der Spoel.
# Consult the AUTHORS/COPYING files and https://www.gromacs.org for details.
#
# GROMACS is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# GROMACS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with GROMACS; if not, see
# https://www.gnu.org/licenses, or write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
#
# If you want to redistribute modifications to GROMACS, please
# consider that scientific software is very special. Version
# control is crucial - bugs must be traceable. We will be happy to
# consider code for inclusion in the official distribution, but
# derived work must not be called official GROMACS. Details are found
# in the README & COPYING files - if they are missing, get the
# official version at https://www.gromacs.org.
#
# To help us fund GROMACS development, we humbly ask that you cite
# the research papers on the package. Check out https://www.gromacs.org.

cmake_minimum_required(VERSION 3.28)
cmake_policy(VERSION 3.28)

project(AdaptiveCppTest)
find_package(adaptivecpp REQUIRED)

# This project will fail compilation if it can't use AdaptiveCpp compiler,
# and will emit a warning for each of the known compilation targets:
# - "GMX_ACPP_TEST_HAVE_CUDA_TARGET" for CUDA
# - "GMX_ACPP_TEST_HAVE_HIP_TARGET" for HIP
# - "GMX_ACPP_TEST_HAVE_LEVELZERO_TARGET" for deprecated LevelZero
# - "GMX_ACPP_TEST_HAVE_GENERIC_TARGET" for generic/SSCP

add_executable(AdaptiveCppTest main.cpp)
add_sycl_to_target(TARGET AdaptiveCppTest SOURCES main.cpp)

=== share/template/CMakeLists.txt ===
#
# This file is part of the GROMACS molecular simulation package.
#
# Copyright 2011- The GROMACS Authors
# and the project initiators Erik Lindahl, Berk Hess and David van der Spoel.
# Consult the AUTHORS/COPYING files and https://www.gromacs.org for details.
#
# GROMACS is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# GROMACS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with GROMACS; if not, see
# https://www.gnu.org/licenses, or write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
#
# If you want to redistribute modifications to GROMACS, please
# consider that scientific software is very special. Version
# control is crucial - bugs must be traceable. We will be happy to
# consider code for inclusion in the official distribution, but
# derived work must not be called official GROMACS. Details are found
# in the README & COPYING files - if they are missing, get the
# official version at https://www.gromacs.org.
#
# To help us fund GROMACS development, we humbly ask that you cite
# the research papers on the package. Check out https://www.gromacs.org.

add_executable(template template.cpp)
if (MSVC)
    gmx_target_warning_suppression(template /wd4244 HAS_NO_MSVC_LOSSY_CONVERSION_DOUBLE_TO_REAL)
    gmx_target_warning_suppression(template /wd4267 HAS_NO_MSVC_LOSSY_CONVERSION_SIZE_T_TO_INT)
endif()
# This should be removable once object libraries can directly use target_link_libraries
# with CMake 3.12, #3290
target_include_directories(template SYSTEM PRIVATE ${PROJECT_SOURCE_DIR}/src/external)
target_link_libraries(template PRIVATE libgromacs legacy_modules legacy_api ${GMX_EXE_LINKER_FLAGS})

# Ensure that libsycl is properly linked when libgromacs is a static
# library.
#
# TODO The second predicate is used in release-2025 branch to
# maximize stability of the default shared-library build
# configuration. After merging to main branch, remove the second
# predicate, because it may be useful and seems unlikely to cause
# harm.
if(GMX_GPU_SYCL AND NOT BUILD_SHARED_LIBS)
    # There are no source files to gmx that need to compile as
    # SYCL, so none are provided here.
    add_sycl_to_target(TARGET template)
endif()

set(DOCUMENTATION_HTTP_URL_BASE
    https://manual.gromacs.org/nightly/index.html)
if (SOURCE_IS_SOURCE_DISTRIBUTION)
    set(DOCUMENTATION_HTTP_URL_BASE
        http://manual.gromacs.org/documentation/${GMX_VERSION_STRING})
endif()
configure_file(README.cmakein README @ONLY)

install(FILES CMakeLists.txt.template
        DESTINATION ${GMX_INSTALL_GMXDATADIR}/template
        RENAME CMakeLists.txt
        COMPONENT development)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/README template.cpp Makefile.pkg
        DESTINATION ${GMX_INSTALL_GMXDATADIR}/template
        COMPONENT development)

install(FILES cmake/FindGROMACS.cmake
        DESTINATION ${GMX_INSTALL_GMXDATADIR}/template/cmake
        COMPONENT development)

=== src/external/CMakeLists.txt ===
#
# This file is part of the GROMACS molecular simulation package.
#
# Copyright 2011- The GROMACS Authors
# and the project initiators Erik Lindahl, Berk Hess and David van der Spoel.
# Consult the AUTHORS/COPYING files and https://www.gromacs.org for details.
#
# GROMACS is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# GROMACS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with GROMACS; if not, see
# https://www.gnu.org/licenses, or write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
#
# If you want to redistribute modifications to GROMACS, please
# consider that scientific software is very special. Version
# control is crucial - bugs must be traceable. We will be happy to
# consider code for inclusion in the official distribution, but
# derived work must not be called official GROMACS. Details are found
# in the README & COPYING files - if they are missing, get the
# official version at https://www.gromacs.org.
#
# To help us fund GROMACS development, we humbly ask that you cite
# the research papers on the package. Check out https://www.gromacs.org.

if(BUILD_TESTING AND GMX_BUILD_UNITTESTS)
    # GTest/GMock suggest linking with pthreads when available for thread safety
    set(CMAKE_THREAD_PREFER_PTHREAD 1)
    find_package(Threads)
    if (CMAKE_USE_PTHREADS_INIT)
        # Input to googletest CMake scripts
        set(GTEST_HAS_PTHREAD 1)
        # Output for consumption in GROMACS build tree
        set(GTEST_IS_THREADSAFE 1)
    else()
        # Input to googletest CMake scripts
        set(GTEST_HAS_PTHREAD 0)
        # Output for consumption in GROMACS build tree
        set(GTEST_IS_THREADSAFE 0)
    endif()

    option(BUILD_GMOCK "googletest: Builds the googlemock subproject. GROMACS uses googlemock." ON)
    option(INSTALL_GTEST "googletest: Enable installation of googletest. GROMACS uses it internally; installation not needed." OFF)
    add_subdirectory(googletest EXCLUDE_FROM_ALL)
    mark_as_advanced(BUILD_GMOCK)
    mark_as_advanced(INSTALL_GTEST)
    mark_as_advanced(GTEST_HAS_ABSL)
    target_compile_definitions(gmock
        PRIVATE
            _GNU_SOURCE=1
            GTEST_CAN_STREAM_RESULTS=0
            )
    if(BUILD_SHARED_LIBS)
        foreach(_lib gmock gtest)
            target_compile_definitions(${_lib}
                PRIVATE
                    GTEST_CREATE_SHARED_LIBRARY=1
                INTERFACE
                    GTEST_LINKED_AS_SHARED_LIBRARY=1
                )
        endforeach()
    endif()
    if (CYGWIN)
        # Ensure GoogleTest and things that use it can find
        # POSIX things needed by GoogleTest
        target_compile_definitions(gtest PUBLIC _POSIX_C_SOURCE=200809L)
    endif()
    gmx_target_warning_suppression(gmock -Wno-deprecated-copy HAVE_NO_DEPRECATED_COPY)
    if (CMAKE_BUILD_TYPE MATCHES "Debug")
        gmx_target_warning_suppression(gtest -Wno-debug-disables-optimization HAVE_NO_DEBUG_DISABLES_OPTIMIZATION)
        gmx_target_warning_suppression(gmock -Wno-debug-disables-optimization HAVE_NO_DEBUG_DISABLES_OPTIMIZATION)
    endif()
    if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        gmx_target_warning_suppression(gtest -Wno-implicit-int-float-conversion HAVE_NO_IMPLICIT_INT_FLOAT_CONVERSION)
    endif()
    # Intel LLVM 2021.2 defaults to no-finite-math which isn't OK
    if(GMX_INTEL_LLVM)
        if (WIN32)
            set (_flag "/fp:precise")
        else()
            set(_flag "-fno-finite-math-only")
        endif()
        gmx_target_warning_suppression(gmock ${_flag} HAS_NO_FINITE_MATH_ONLY)
        gmx_target_warning_suppression(gtest ${_flag} HAS_NO_FINITE_MATH_ONLY)
    endif()

    set(GTEST_IS_THREADSAFE "${GTEST_IS_THREADSAFE}" PARENT_SCOPE)

    add_subdirectory(thread_mpi/test)
endif()
add_subdirectory(boost)
add_subdirectory(rpc_xdr)

=== src/testutils/CMakeLists.txt ===
#
# This file is part of the GROMACS molecular simulation package.
#
# Copyright 2011- The GROMACS Authors
# and the project initiators Erik Lindahl, Berk Hess and David van der Spoel.
# Consult the AUTHORS/COPYING files and https://www.gromacs.org for details.
#
# GROMACS is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# GROMACS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with GROMACS; if not, see
# https://www.gnu.org/licenses, or write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
#
# If you want to redistribute modifications to GROMACS, please
# consider that scientific software is very special. Version
# control is crucial - bugs must be traceable. We will be happy to
# consider code for inclusion in the official distribution, but
# derived work must not be called official GROMACS. Details are found
# in the README & COPYING files - if they are missing, get the
# official version at https://www.gromacs.org.
#
# To help us fund GROMACS development, we humbly ask that you cite
# the research papers on the package. Check out https://www.gromacs.org.

if (NOT GMX_BUILD_UNITTESTS)
    gmx_add_missing_tests_notice("Unit tests have not been run. You need to set GMX_BUILD_UNITTESTS=ON if you want to build and run them.")
    return()
endif()

if (GMX_GPU_CUDA)
    add_library(testutils)

    #we cannot link with both cufftmp and cufft
    if(GMX_USE_cuFFTMp)
        target_link_libraries(testutils PRIVATE ${cuFFTMp_LIBRARY})
    else()
        target_link_libraries(testutils PRIVATE CUDA::cufft)
    endif()
    if (GMX_NVSHMEM)
        target_link_libraries(testutils PUBLIC nvshmem_host_lib)
    endif()
elseif (GMX_GPU_HIP)
    set_source_files_properties(test_device.cpp PROPERTIES LANGUAGE HIP)
    gmx_hip_add_library(testutils test_device.cpp)

    target_link_libraries(testutils PRIVATE hip::host)
    if (GMX_GPU_FFT_VKFFT)
        target_link_libraries(testutils PRIVATE VkFFT)
    elseif(GMX_GPU_FFT_ROCFFT)
        target_link_libraries(testutils PRIVATE roc::rocfft)
    endif()
else()
    add_library(testutils STATIC ${UNITTEST_TARGET_OPTIONS})
endif()

# Module interface / provided facilities
target_include_directories(testutils PUBLIC include)

# Executable targets for tests based on `testutils` acquire the source for
# their entry point from unittest_main.cpp when linking to the `testutils` target.
target_sources(testutils INTERFACE unittest_main.cpp)


target_sources(testutils PRIVATE
               cmdlinetest.cpp
               conftest.cpp
               filematchers.cpp
               interactivetest.cpp
               loggertest.cpp
               mpi_printer.cpp
               mpitest.cpp
               posixmemstream.cpp
               refdata.cpp
               refdata_xml.cpp
               setenv.cpp
               simulationdatabase.cpp
               stdiohelper.cpp
               stringtest.cpp
               testasserts.cpp
               testfilemanager.cpp
               testfileredirector.cpp
               test_device.cpp
               test_hardware_environment.cpp
               testinit.cpp
               testmatchers.cpp
               testoptions.cpp
               textblockmatchers.cpp
               topologyhelpers.cpp
               tprfilegenerator.cpp
               trajectoryreader.cpp
               xvgtest.cpp
               )


if(HAVE_TINYXML2)
    target_include_directories(testutils SYSTEM PRIVATE ${TinyXML2_INCLUDE_DIR})
    target_link_libraries(testutils PRIVATE ${TinyXML2_LIBRARIES})
else()
    target_include_directories(testutils SYSTEM BEFORE PRIVATE ${CMAKE_SOURCE_DIR}/src/external/tinyxml2)
    target_sources(testutils PRIVATE ${CMAKE_SOURCE_DIR}/src/external/tinyxml2/tinyxml2.cpp)
endif()

target_include_directories(testutils PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

if (GMX_GPU_SYCL)
    add_sycl_to_target(
        TARGET testutils
        SOURCES test_device.cpp
        )
endif()

gmx_target_compile_options(testutils)
target_compile_definitions(testutils PRIVATE HAVE_CONFIG_H)
target_include_directories(testutils SYSTEM BEFORE PRIVATE ${PROJECT_SOURCE_DIR}/src/external/thread_mpi/include)
target_compile_definitions(testutils PRIVATE TMPI_USE_VISIBILITY)
target_link_libraries(testutils PRIVATE libgromacs ${GMX_COMMON_LIBRARIES} gmock)
target_link_libraries(testutils PUBLIC common)

# GROMACS module dependencies.
# Note that testutils conveys transitive dependencies on some modules.
# TODO: Remove `legacy_modules` once specific modules are explicitly linked.
target_link_libraries(testutils PUBLIC legacy_modules)
target_link_libraries(testutils PUBLIC utility math)
target_link_libraries(testutils PRIVATE topology)

# Permit having tests of legacy functions using FILE*, which work best
# when the system supports the POSIX open_memstream() function.
include(CheckCXXSymbolExists)
check_cxx_symbol_exists("open_memstream" "cstdio" HAVE_OPEN_MEMSTREAM)
if (HAVE_OPEN_MEMSTREAM)
    set(_have_open_memstream_value 1)
else()
    set(_have_open_memstream_value 0)
endif()
set_source_files_properties(posixmemstream.cpp PROPERTIES COMPILE_DEFINITIONS "-DHAVE_OPEN_MEMSTREAM=${_have_open_memstream_value}")

add_subdirectory(tests)

=== src/external/googletest/CMakeLists.txt ===
# Note: CMake support is community-based. The maintainers do not use CMake
# internally.

if(NOT DEFINED CMAKE_MINIMUM_REQUIRED_VERSION)
  cmake_minimum_required(VERSION 3.28)
endif()

project(googletest-distribution)
set(GOOGLETEST_VERSION 1.17.0)

if(NOT CYGWIN AND NOT MSYS AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL QNX)
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

enable_testing()

include(CMakeDependentOption)
include(GNUInstallDirs)

# Note that googlemock target already builds googletest.
option(BUILD_GMOCK "Builds the googlemock subproject" ON)
option(INSTALL_GTEST "Enable installation of googletest. (Projects embedding googletest may want to turn this OFF.)" ON)
option(GTEST_HAS_ABSL "Use Abseil and RE2. Requires Abseil and RE2 to be separately added to the build." OFF)

if(GTEST_HAS_ABSL)
  if(NOT TARGET absl::base)
    find_package(absl REQUIRED)
  endif()
  if(NOT TARGET re2::re2)
    find_package(re2 REQUIRED)
  endif()
endif()

if(BUILD_GMOCK)
  add_subdirectory( googlemock )
else()
  add_subdirectory( googletest )
endif()

=== src/external/muparser/CMakeLists.txt ===
# CMake based on work from @xantares
if(NOT DEFINED CMAKE_MINIMUM_REQUIRED_VERSION)
  cmake_minimum_required (VERSION 3.28)
endif()
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# By default, build in Release mode. Must appear before project() command
if (NOT DEFINED CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
endif ()

project(muParserProject)

# Bump versions on release
set(MUPARSER_VERSION_MAJOR 2)
set(MUPARSER_VERSION_MINOR 3)
set(MUPARSER_VERSION_PATCH 4)
set(MUPARSER_VERSION ${MUPARSER_VERSION_MAJOR}.${MUPARSER_VERSION_MINOR}.${MUPARSER_VERSION_PATCH})

# Build options
option(ENABLE_SAMPLES "Build the samples" ON)
option(ENABLE_OPENMP "Enable OpenMP for multithreading" ON)
option(ENABLE_WIDE_CHAR "Enable wide character support" OFF)
option(BUILD_SHARED_LIBS "Build shared/static libs" ON)

if(ENABLE_OPENMP)
    find_package(OpenMP REQUIRED COMPONENTS CXX)
endif()

# Credit: https://stackoverflow.com/questions/2368811/how-to-set-warning-level-in-cmake/3818084
if(MSVC)
    # Force to always compile with W4
    if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
      string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    else()
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
    endif()
elseif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
    # Update if necessary
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-long-long -pedantic")
endif()

file(GLOB_RECURSE MUPARSER_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp") #all .cpp
# The test file produces warnings with MSVC and was recommended for exclusion, see
# https://github.com/beltoforion/muparser/issues/142#issuecomment-2093561006
list(REMOVE_ITEM MUPARSER_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/src/muParserTest.cpp")
add_library(muparser ${MUPARSER_SOURCES})

# Use the headers in the build-tree or the installed ones
target_include_directories(muparser SYSTEM PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

# This compiles the "DLL" interface (C API)
target_compile_definitions(muparser PRIVATE MUPARSER_DLL)

# Intel LLVM 2021.2 and later defaults to no-finite-math which isn't OK
if(GMX_INTEL_LLVM)
    if (WIN32)
        set (_flag "/fp:precise")
    else()
        set(_flag "-fno-finite-math-only")
    endif()
    gmx_target_warning_suppression(muparser ${_flag} HAS_NO_FINITE_MATH_ONLY)
endif()

if (BUILD_SHARED_LIBS)
  target_compile_definitions(muparser PRIVATE MUPARSERLIB_EXPORTS)
  add_definitions( -DMUPARSERLIB_EXPORTS )
else ()
  target_compile_definitions(muparser PUBLIC MUPARSER_STATIC)
  add_definitions( -DMUPARSER_STATIC )
endif()

if (CMAKE_BUILD_TYPE STREQUAL Debug)
  target_compile_definitions(muparser PRIVATE _DEBUG)
endif ()

if(ENABLE_OPENMP)
  target_compile_definitions(muparser PRIVATE MUP_USE_OPENMP)
  target_link_libraries(muparser PRIVATE OpenMP::OpenMP_CXX)
endif()

if(ENABLE_WIDE_CHAR)
  target_compile_definitions(muparser PUBLIC _UNICODE)
endif()

set_target_properties(muparser PROPERTIES
    VERSION ${MUPARSER_VERSION}
    SOVERSION ${MUPARSER_VERSION_MAJOR}
)

if(ENABLE_SAMPLES)
  add_executable(example1 samples/example1/example1.cpp)
  target_link_libraries(example1 muparser)

  add_executable(example2 samples/example2/example2.c)
  target_link_libraries(example2 muparser)
endif()

# The GNUInstallDirs defines ${CMAKE_INSTALL_DATAROOTDIR}
# See https://cmake.org/cmake/help/latest/module/GNUInstallDirs.html
include (GNUInstallDirs)
set(INSTALL_CONFIGDIR ${CMAKE_INSTALL_LIBDIR}/cmake/muparser)

install(TARGETS muparser
    EXPORT muparser-export
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development EXCLUDE_FROM_ALL
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeLibraries
)

file(GLOB_RECURSE MUPARSER_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h") #all .h
install(FILES
    ${MUPARSER_HEADERS}
    DESTINATION include
    COMPONENT Development
    EXCLUDE_FROM_ALL
)

# Export the target under the build-tree (no need to install)
export(EXPORT muparser-export
    FILE "${CMAKE_BINARY_DIR}/muparser-targets.cmake"
    NAMESPACE muparser::
)
add_library(muparser::muparser ALIAS muparser)

# Export the installed target (typically for packaging)
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/muparserConfigVersion.cmake"
    VERSION ${MUPARSER_VERSION}
    COMPATIBILITY AnyNewerVersion
)
configure_file(muparserConfig.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/muparserConfig.cmake"
    COPYONLY
)
install(EXPORT muparser-export
    FILE muparser-targets.cmake
    NAMESPACE muparser::
    DESTINATION ${INSTALL_CONFIGDIR}
    EXCLUDE_FROM_ALL
)
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/muparserConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/muparserConfigVersion.cmake
    DESTINATION ${INSTALL_CONFIGDIR}
    COMPONENT Development
    EXCLUDE_FROM_ALL
)

# Define variables for the pkg-config file
set(PACKAGE_NAME muparser)
if(ENABLE_WIDE_CHAR)
  set(PKG_CONFIG_FLAGS "-D_UNICODE")
endif(ENABLE_WIDE_CHAR)
configure_file(
    muparser.pc.in
    ${CMAKE_BINARY_DIR}/muparser.pc
    @ONLY
)
install(
    FILES ${CMAKE_BINARY_DIR}/muparser.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    EXCLUDE_FROM_ALL
)

include(CTest)

if (BUILD_TESTING)
    add_executable (t_ParserTest test/t_ParserTest.cpp)
    target_link_libraries(t_ParserTest muparser)
    add_test (NAME ParserTest COMMAND t_ParserTest)
endif()

=== src/gromacs/domdec/CMakeLists.txt ===
#
# This file is part of the GROMACS molecular simulation package.
#
# Copyright 2014- The GROMACS Authors
# and the project initiators Erik Lindahl, Berk Hess and David van der Spoel.
# Consult the AUTHORS/COPYING files and https://www.gromacs.org for details.
#
# GROMACS is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# GROMACS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with GROMACS; if not, see
# https://www.gnu.org/licenses, or write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
#
# If you want to redistribute modifications to GROMACS, please
# consider that scientific software is very special. Version
# control is crucial - bugs must be traceable. We will be happy to
# consider code for inclusion in the official distribution, but
# derived work must not be called official GROMACS. Details are found
# in the README & COPYING files - if they are missing, get the
# official version at https://www.gromacs.org.
#
# To help us fund GROMACS development, we humbly ask that you cite
# the research papers on the package. Check out https://www.gromacs.org.

# Set up the module library
add_library(domdec INTERFACE)
file(GLOB DOMDEC_SOURCES *.cpp)
list(FILTER DOMDEC_SOURCES EXCLUDE REGEX ".*/gpuhaloexchange_impl_gpu[a-z_]*\.cpp$")
list(FILTER DOMDEC_SOURCES EXCLUDE REGEX ".*/gpuhaloexchange_impl.cpp$")
list(FILTER DOMDEC_SOURCES EXCLUDE REGEX ".*/fused_gpuhaloexchange.cpp$")

if(GMX_GPU_SYCL)
    file(GLOB DOMDEC_GPU_SOURCES gpuhaloexchange_impl_gpu.cpp gpuhaloexchange_impl_gpu_sycl.cpp)
    _gmx_add_files_to_property(SYCL_SOURCES gpuhaloexchange_impl_gpu.cpp gpuhaloexchange_impl_gpu_sycl.cpp)
elseif(GMX_GPU_CUDA)
    if(GMX_NVSHMEM)
        # For NVSHMEM builds, exclude the .cu file from normal compilation
        set(DOMDEC_GPU_SOURCES gpuhaloexchange_impl_gpu.cpp fused_gpuhaloexchange.cpp)
        _gmx_add_files_to_property(CUDA_SOURCES fused_gpuhaloexchange.cpp)
    else()
        set(DOMDEC_GPU_SOURCES gpuhaloexchange_impl_gpu.cpp gpuhaloexchange_impl_gpu.cu)
    endif()
    file(GLOB DOMDEC_GPU_SOURCES ${DOMDEC_GPU_SOURCES})
    _gmx_add_files_to_property(CUDA_SOURCES gpuhaloexchange_impl_gpu.cpp)
elseif(GMX_GPU_HIP)
  file(GLOB DOMDEC_GPU_SOURCES gpuhaloexchange_impl_gpu.cpp gpuhaloexchange_impl_gpu_hip.cpp)
  _gmx_add_files_to_property(HIP_SOURCES gpuhaloexchange_impl_gpu.cpp gpuhaloexchange_impl_gpu_hip.cpp)
else()
  file(GLOB DOMDEC_GPU_SOURCES gpuhaloexchange_impl.cpp)
endif()

set(LIBGROMACS_SOURCES ${LIBGROMACS_SOURCES} ${DOMDEC_SOURCES} ${DOMDEC_GPU_SOURCES} PARENT_SCOPE)

# Source files have the following dependencies on library infrastructure.
#target_link_libraries(domdec PRIVATE
#                      common
#                      legacy_modules
#)

# Public interface for modules, including dependencies and interfaces
#target_include_directories(domdec PUBLIC
#                           $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>)
#target_link_libraries(domdec PUBLIC
target_link_libraries(domdec INTERFACE
                      legacy_api
                      gpu_utils
                      mdlib
                      timing
                      topology
                      utility
                      )

# TODO: when domdec is an OBJECT target
#target_link_libraries(domdec PUBLIC legacy_api)
#target_link_libraries(domdec PRIVATE common)

# Source files have the following private module dependencies.
#target_link_libraries(domdec PRIVATE NOTHING)
# TODO: Explicitly link specific modules.
#target_link_libraries(domdec PRIVATE legacy_modules)

# NVSHMEM-specific static library for separable compilation
if(GMX_NVSHMEM AND GMX_GPU_CUDA)
    gmx_add_library_for_nvshmem(
        TARGET_NAME domdec_halo_gpu
        STATIC
        SOURCES gpuhaloexchange_impl_gpu.cu
        PRIVATE_TARGET_DEPENDENCIES
            legacy_api
            gpu_utils
            mdlib
            timing
            topology
            utility
    )
    # Link the separable library into domdec
    target_link_libraries(domdec INTERFACE domdec_halo_gpu)
endif()

if (BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== src/gromacs/ewald/CMakeLists.txt ===
#
# This file is part of the GROMACS molecular simulation package.
#
# Copyright 2014- The GROMACS Authors
# and the project initiators Erik Lindahl, Berk Hess and David van der Spoel.
# Consult the AUTHORS/COPYING files and https://www.gromacs.org for details.
#
# GROMACS is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# GROMACS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with GROMACS; if not, see
# https://www.gnu.org/licenses, or write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
#
# If you want to redistribute modifications to GROMACS, please
# consider that scientific software is very special. Version
# control is crucial - bugs must be traceable. We will be happy to
# consider code for inclusion in the official distribution, but
# derived work must not be called official GROMACS. Details are found
# in the README & COPYING files - if they are missing, get the
# official version at https://www.gromacs.org.
#
# To help us fund GROMACS development, we humbly ask that you cite
# the research papers on the package. Check out https://www.gromacs.org.

# Set up the module library
add_library(ewald INTERFACE)
gmx_add_libgromacs_sources(
    calculate_spline_moduli.cpp
    ewald.cpp
    ewald_utils.cpp
    long_range_correction.cpp
    pme.cpp
    pme_gather.cpp
    pme_grid.cpp
    pme_load_balancing.cpp
    pme_only.cpp
    pme_pp.cpp
    pme_redistribute.cpp
    pme_solve.cpp
    pme_spline_work.cpp
    pme_spread.cpp
    pme_gpu_program.cpp
    )

if (GMX_GPU_CUDA)
    gmx_add_libgromacs_sources(
        # CUDA-specific sources
        pme_gpu_program_impl.cu
        pme_pp_comm_gpu_impl_gpu.cpp
        pme_pp_comm_gpu_impl_gpu.cu
        pme_force_sender_gpu_impl_gpu.cpp
        pme_force_sender_gpu_impl_gpu.cu
        pme_coordinate_receiver_gpu_impl_gpu.cpp
        pme_gpu_grid.cu
        # GPU-specific sources
        pme_gpu.cpp
        pme_gpu_internal.cpp
        pme_gpu_timings.cpp
        )
    _gmx_add_files_to_property(CUDA_SOURCES
        pme_pp_comm_gpu_impl_gpu.cpp
        pme_force_sender_gpu_impl_gpu.cpp
        pme_coordinate_receiver_gpu_impl_gpu.cpp
        pme_gpu_internal.cpp
        )
    # Clang-18 seems to emit bad ptx for these files, so we omit it from
    # the CI build that does clang-tidy analysis of a CUDA build.
    if (NOT GMX_CLANG_TIDY)
        if(GMX_NVSHMEM)
            # For NVSHMEM builds, exclude pme_gather.cu from normal compilation
            gmx_add_libgromacs_sources(
                pme_solve.cu
                pme_spread.cu
            )
        else()
            gmx_add_libgromacs_sources(
                pme_gather.cu
                pme_solve.cu
                pme_spread.cu
            )
        endif()
    endif()
elseif (GMX_GPU_OPENCL)
    gmx_add_libgromacs_sources(
        # OpenCL-specific sources
        pme_gpu_program_impl_ocl.cpp
        pme_gpu_ocl_stubs.cpp
        pme_pp_comm_gpu_impl.cpp
        pme_coordinate_receiver_gpu_impl.cpp
        pme_force_sender_gpu_impl.cpp
        # GPU-specific sources
        pme_gpu.cpp
        pme_gpu_internal.cpp
        pme_gpu_timings.cpp
        # General implementation stubs
        pme_force_sender_gpu_impl.cpp
        pme_coordinate_receiver_gpu_impl.cpp
        pme_pp_comm_gpu_impl.cpp
)
elseif (GMX_GPU_HIP)
    gmx_add_libgromacs_sources(
        # HIP-specific sources
        pme_gather_hip.cpp
        pme_gpu.cpp
        pme_gpu_grid_hip.cpp
        pme_gpu_internal.cpp
        pme_gpu_program_impl_hip.cpp
        pme_gpu_timings.cpp
        pme_solve_hip.cpp
        pme_spread_hip.cpp
        pme_pp_comm_gpu_impl_gpu_hip.cpp
        pme_force_sender_gpu_impl_gpu_hip.cpp
        pme_pp_comm_gpu_impl_gpu.cpp
        pme_force_sender_gpu_impl_gpu.cpp
        pme_force_sender_gpu_impl_gpu_hip.cpp
        pme_coordinate_receiver_gpu_impl_gpu.cpp
        )
    _gmx_add_files_to_property(HIP_SOURCES
        # Must add these files so they can include device_information.h
        pme_gather_hip.cpp
        pme_gpu_grid_hip.cpp
        pme_gpu_internal.cpp
        pme_gpu_program.cpp
        pme_gpu_program_impl_hip.cpp
        pme_gpu_3dfft_hip.cpp
        pme_gpu_timings.cpp
        pme_pp_comm_gpu_impl_gpu.cpp
        pme_pp_comm_gpu_impl_gpu_hip.cpp
        pme_force_sender_gpu_impl_gpu.cpp
        pme_force_sender_gpu_impl_gpu_hip.cpp
        pme_coordinate_receiver_gpu_impl_gpu.cpp
        pme_solve_hip.cpp
        pme_spread_hip.cpp
        )
elseif (GMX_GPU_SYCL)
    gmx_add_libgromacs_sources(
        # GPU-specific sources
        pme_gather_sycl.cpp
        pme_gpu.cpp
        pme_gpu_grid_sycl.cpp
        pme_gpu_internal.cpp
        pme_gpu_program_impl_sycl.cpp
        pme_gpu_timings.cpp
        pme_solve_sycl.cpp
        pme_spread_sycl.cpp
        pme_pp_comm_gpu_impl_gpu_sycl.cpp
        pme_force_sender_gpu_impl_gpu_sycl.cpp
        pme_pp_comm_gpu_impl_gpu.cpp
        pme_force_sender_gpu_impl_gpu.cpp
        pme_force_sender_gpu_impl_gpu_sycl.cpp
        pme_coordinate_receiver_gpu_impl_gpu.cpp
        )
    _gmx_add_files_to_property(SYCL_SOURCES
        pme_gather_sycl.cpp
        pme_gpu_grid_sycl.cpp
        pme_gpu_internal.cpp
        pme_gpu_program.cpp
        pme_gpu_program_impl_sycl.cpp
        pme_gpu_3dfft_sycl.cpp
        pme_gpu_timings.cpp
        pme_pp_comm_gpu_impl_gpu.cpp
        pme_pp_comm_gpu_impl_gpu_sycl.cpp
        pme_force_sender_gpu_impl_gpu.cpp
        pme_force_sender_gpu_impl_gpu_sycl.cpp
        pme_coordinate_receiver_gpu_impl_gpu.cpp
        pme_solve_sycl.cpp
        pme_spread_sycl.cpp
      )
else()
    gmx_add_libgromacs_sources(
        # Files that implement stubs
        pme_gpu_program_impl.cpp
        pme_pp_comm_gpu_impl.cpp
        pme_coordinate_receiver_gpu_impl.cpp
        pme_force_sender_gpu_impl.cpp
        )
endif()

# Source files have the following private module dependencies.
target_link_libraries(ewald PRIVATE
                      #                      gmxlib
                      #                      math
                      #                      mdtypes
                      #                      tng_io
                      )

# Public interface for modules, including dependencies and interfaces
#target_include_directories(ewald PUBLIC
#                           $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>)
#target_link_libraries(ewald PUBLIC
target_link_libraries(ewald INTERFACE
                      legacy_api
                      )

# TODO: when fileio is an OBJECT target
#target_link_libraries(ewald PUBLIC legacy_api)
#target_link_libraries(ewald PRIVATE common)

# Source files have the following private module dependencies.
#target_link_libraries(ewald PRIVATE tng_io)
# TODO: Explicitly link specific modules.
#target_link_libraries(ewald PRIVATE legacy_modules)

# NVSHMEM-specific separable compilation
if(GMX_NVSHMEM AND GMX_GPU_CUDA)
    # Create a separate library for pme_gather.cu with separable compilation
    # Clang-18 seems to emit bad ptx for these files, so we omit it from
    # the CI build that does clang-tidy analysis of a CUDA build.
    if (NOT GMX_CLANG_TIDY)
        gmx_add_library_for_nvshmem(
            TARGET_NAME ewald_pme_gather_gpu
            STATIC
            SOURCES pme_gather.cu
            PRIVATE_TARGET_DEPENDENCIES
                utility
                math
        )
        # Link the separable library to the main ewald library
        target_link_libraries(ewald INTERFACE ewald_pme_gather_gpu)
    endif()
endif()

if (BUILD_TESTING)
    add_subdirectory(tests)
endif()


set(PME_OCL_KERNEL_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/pme_gpu_calculate_splines.clh"
    "${CMAKE_CURRENT_SOURCE_DIR}/pme_solve.clh"
    "${CMAKE_CURRENT_SOURCE_DIR}/pme_gather.clh"
    "${CMAKE_CURRENT_SOURCE_DIR}/pme_spread.clh")

if(CLANG_TIDY_EXE)
   set(OCL_COMPILER "${CLANG_TIDY_EXE}")
   set(CLANG_TIDY_ARGS "-quiet;-checks=*,-readability-implicit-bool-conversion,-llvm-header-guard,-hicpp-signed-bitwise,-clang-analyzer-deadcode.DeadStores,-google-readability-todo,-clang-diagnostic-padded,-fcomment-block-commands=internal;--;${CMAKE_C_COMPILER}")
else()
   set(OCL_COMPILER "${CMAKE_C_COMPILER}")
endif()

# TODO: test all warp sizes on all vendor targets?
foreach(VENDOR AMD NVIDIA INTEL APPLE)
    foreach(WARPSIZE 16 32 64)
        math(EXPR SPREAD_WG_SIZE "8*${WARPSIZE}")
        math(EXPR SOLVE_WG_SIZE "8*${WARPSIZE}")
        math(EXPR GATHER_WG_SIZE "4*${WARPSIZE}")
        set(OBJ_FILE pme_ocl_kernel_warpSize${WARPSIZE}_${VENDOR}.o)
        add_custom_command(OUTPUT ${OBJ_FILE} COMMAND ${OCL_COMPILER}
        ${CMAKE_CURRENT_SOURCE_DIR}/pme_program.cl ${CLANG_TIDY_ARGS}
        -Xclang -finclude-default-header  -D_${VENDOR}_SOURCE_
        -Dwarp_size=${WARPSIZE}
        -Dorder=4
        -DthreadsPerAtom=16
        -Dc_pmeMaxUnitcellShift=2
        -Dc_skipNeutralAtoms=false
        -Dc_virialAndEnergyCount=7
        -Dc_spreadWorkGroupSize=${SPREAD_WG_SIZE}
        -Dc_solveMaxWorkGroupSize=${SOLVE_WG_SIZE}
        -Dc_gatherWorkGroupSize=${GATHER_WG_SIZE}
        -DDIM=3 -DXX=0 -DYY=1 -DZZ=2
        -DwrapX=true -DwrapY=true
        -c -I ${CMAKE_SOURCE_DIR}/src -std=cl1.2
        -Weverything  -Wno-conversion -Wno-missing-variable-declarations -Wno-used-but-marked-unused
        -Wno-cast-align -Wno-incompatible-pointer-types
        # to avoid  "warning: unknown command tag name" for \internal
        -Wno-documentation-unknown-command
        # to avoid pme_gpu_types.h:100:52: warning: padding struct 'struct PmeGpuConstParams' with 4 bytes to align 'd_virialAndEnergy'
        -Wno-padded
        -o${OBJ_FILE}
        )
        list(APPEND PME_OCL_KERNELS ${OBJ_FILE})
    endforeach()
endforeach()

add_custom_target(ocl_pme_kernels DEPENDS ${PME_OCL_KERNELS} )
gmx_set_custom_target_output(ocl_pme_kernels ${PME_OCL_KERNELS})

=== src/gromacs/fileio/CMakeLists.txt ===
#
# This file is part of the GROMACS molecular simulation package.
#
# Copyright 2013- The GROMACS Authors
# and the project initiators Erik Lindahl, Berk Hess and David van der Spoel.
# Consult the AUTHORS/COPYING files and https://www.gromacs.org for details.
#
# GROMACS is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# GROMACS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with GROMACS; if not, see
# https://www.gnu.org/licenses, or write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
#
# If you want to redistribute modifications to GROMACS, please
# consider that scientific software is very special. Version
# control is crucial - bugs must be traceable. We will be happy to
# consider code for inclusion in the official distribution, but
# derived work must not be called official GROMACS. Details are found
# in the README & COPYING files - if they are missing, get the
# official version at https://www.gromacs.org.
#
# To help us fund GROMACS development, we humbly ask that you cite
# the research papers on the package. Check out https://www.gromacs.org.

# Set up the module library
add_library(fileio INTERFACE)
file(GLOB FILEIO_SOURCES *.cpp)

add_subdirectory(h5md)

if(GMX_USE_PLUGINS)
    add_library(vmddlopen OBJECT ${CMAKE_SOURCE_DIR}/src/external/vmd_molfile/vmddlopen.cpp)
    gmx_target_compile_options(vmddlopen)
    if (MSVC)
        gmx_target_warning_suppression(vmddlopen /wd4996 HAS_NO_MSVC_UNSAFE_FUNCTION)
    endif()
    list(APPEND libgromacs_object_library_dependencies vmddlopen)
    set(libgromacs_object_library_dependencies ${libgromacs_object_library_dependencies} PARENT_SCOPE)
else()
    # Remove vmdio.cpp from sources since we do not have plugin support
    list(FILTER FILEIO_SOURCES EXCLUDE REGEX ".*vmdio.cpp$")
endif()

# Source files have the following private module dependencies.
target_link_libraries(fileio PRIVATE
#                      gmxlib
#                      math
#                      mdtypes
#                      tng_io
                      )

# Only needed for XDR routines that cast xdr_char and the like to xdrproc_t.
# TODO: Convert to gmx_target_warning_suppression when fileio in an OBJECT target
gmx_target_interface_warning_suppression(fileio "-Wno-cast-function-type-strict" HAS_WARNING_NO_CAST_FUNCTION_TYPE_STRICT)

# Public interface for modules, including dependencies and interfaces
#target_include_directories(fileio PUBLIC
#                           $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>)
#target_link_libraries(fileio PUBLIC
target_link_libraries(fileio INTERFACE
                      h5md
                      legacy_api
                      math
                      )

# TODO: when fileio is an OBJECT target
#target_link_libraries(fileio PUBLIC legacy_api)
#target_link_libraries(fileio PRIVATE common)

# Module dependencies
# fileio interfaces convey transitive dependence on these modules.
#target_link_libraries(fileio PUBLIC
target_link_libraries(fileio INTERFACE
                      serialization
                      utility
                      )

# Source files have the following private module dependencies.
#target_link_libraries(fileio PRIVATE tng_io)
# TODO: Explicitly link specific modules.
#target_link_libraries(fileio PRIVATE legacy_modules)

target_sources(libgromacs PRIVATE ${FILEIO_SOURCES})

if (BUILD_TESTING)
     add_subdirectory(tests)
endif()

=== src/gromacs/fmm/CMakeLists.txt ===
#
# This file is part of the GROMACS molecular simulation package.
#
# Copyright 2025- The GROMACS Authors
# and the project initiators Erik Lindahl, Berk Hess and David van der Spoel.
# Consult the AUTHORS/COPYING files and https://www.gromacs.org for details.
#
# GROMACS is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# GROMACS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with GROMACS; if not, see
# https://www.gnu.org/licenses, or write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
#
# If you want to redistribute modifications to GROMACS, please
# consider that scientific software is very special. Version
# control is crucial - bugs must be traceable. We will be happy to
# consider code for inclusion in the official distribution, but
# derived work must not be called official GROMACS. Details are found
# in the README & COPYING files - if they are missing, get the
# official version at https://www.gromacs.org.
#
# To help us fund GROMACS development, we humbly ask that you cite
# the research papers on the package. Check out https://www.gromacs.org.

add_library(fmm OBJECT)

gmx_manage_fmm()

target_sources(fmm PRIVATE
    fmm_mdmodule.cpp
    fmm_mdpoptions.cpp
    fmm_mdpvalidator.cpp
    fmmforceproviderbuilder.cpp
    fmmoptions.cpp
)

if(GMX_USE_EXT_FMM)
    target_sources(fmm PRIVATE
        fmmforceprovider.cpp
    )

else()
    target_sources(fmm PRIVATE
        fmmforceprovider_stub.cpp
    )

endif()

if (BUILD_SHARED_LIBS)
    set_target_properties(fmm PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

gmx_target_compile_options(fmm)
target_compile_definitions(fmm PRIVATE HAVE_CONFIG_H)

target_link_libraries(fmm PRIVATE
    common
    legacy_modules
    math
    mdtypes
    topology
    utility
    )

if (BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== src/gromacs/gpu_utils/CMakeLists.txt ===
#
# This file is part of the GROMACS molecular simulation package.
#
# Copyright 2015- The GROMACS Authors
# and the project initiators Erik Lindahl, Berk Hess and David van der Spoel.
# Consult the AUTHORS/COPYING files and https://www.gromacs.org for details.
#
# GROMACS is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# GROMACS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with GROMACS; if not, see
# https://www.gnu.org/licenses, or write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
#
# If you want to redistribute modifications to GROMACS, please
# consider that scientific software is very special. Version
# control is crucial - bugs must be traceable. We will be happy to
# consider code for inclusion in the official distribution, but
# derived work must not be called official GROMACS. Details are found
# in the README & COPYING files - if they are missing, get the
# official version at https://www.gromacs.org.
#
# To help us fund GROMACS development, we humbly ask that you cite
# the research papers on the package. Check out https://www.gromacs.org.

# Note, source files should be listed in alphabetical order, to reduce
# the incidence of textual clashes when adding/moving files that
# otherwise make the end of the list a hotspot.

add_library(gpu_utils INTERFACE)

gmx_add_libgromacs_sources(
        binary_information.cpp
        clfftinitializer.cpp
        device_stream_manager.cpp
        gpu_utils.cpp
        gpueventsynchronizer_helpers.cpp
        hostallocator.cpp
        nvshmem_manager.cpp
        )
if(GMX_GPU_OPENCL)
    gmx_add_libgromacs_sources(
        device_context_ocl.cpp
        device_stream_ocl.cpp
        gpu_utils_impl.cpp
        pmalloc.cpp
        ocl_compiler.cpp
        ocl_caching.cpp
        oclutils.cpp
        )
elseif(GMX_GPU_CUDA)
    gmx_add_libgromacs_sources(
        device_context.cpp
        device_stream.cu
        gpu_utils.cu
        pmalloc.cu
        )
    _gmx_add_files_to_property(CUDA_SOURCES
        binary_information.cpp
        device_stream_manager.cpp
        nvshmem_manager.cpp
        )
elseif(GMX_GPU_HIP)
    gmx_add_libgromacs_sources(
        device_context.cpp
        device_stream_hip.cpp
        gpu_utils_hip.cpp
        pmalloc_hip.cpp
        )
    _gmx_add_files_to_property(HIP_SOURCES
        binary_information.cpp
        device_stream_hip.cpp
        gpu_utils_hip.cpp
        pmalloc_hip.cpp
        )
elseif(GMX_GPU_SYCL)
    gmx_add_libgromacs_sources(
        devicebuffer_sycl.cpp
        device_context_sycl.cpp
        device_stream_sycl.cpp
        gpu_utils_impl.cpp
        pmalloc_sycl.cpp
        )
    _gmx_add_files_to_property(SYCL_SOURCES
        binary_information.cpp
        devicebuffer_sycl.cpp
        device_context_manager.cpp
        device_context_sycl.cpp
        device_stream_manager.cpp
        device_stream_sycl.cpp
        pmalloc_sycl.cpp
        )
else()
    gmx_add_libgromacs_sources(
        device_context.cpp
        device_stream.cpp
        gpu_utils_impl.cpp
        pmalloc.cpp
    )
endif()

# Source files have the following private module dependencies.
target_link_libraries(gpu_utils PRIVATE
#                      gmxlib
#                      math
#                      mdtypes
#                      tng_io
                      )

# Public interface for modules, including dependencies and interfaces
#target_include_directories(gpu_utils PUBLIC
#                           $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>)
#target_link_libraries(gpu_utils PUBLIC
target_link_libraries(gpu_utils INTERFACE
                      legacy_api
                      math
                      )

# TODO: when gpu_utils is an OBJECT target
#target_link_libraries(gpu_utils PUBLIC legacy_api)
#target_link_libraries(gpu_utils PRIVATE common)

# Source files have the following private module dependencies.
#target_link_libraries(gpu_utils PRIVATE tng_io)
# TODO: Explicitly link specific modules.
#target_link_libraries(gpu_utils PRIVATE legacy_modules)

if (BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== debian/changelog ===
gromacs (2026~rc-1) experimental; urgency=medium

  * New upstream release candidate.  Upload to experimental.
    - SONAME bump: libgromacs10 -> libgromacs11.
  * Disable library API documentation, due to doxygen incompatibilities.
    (https://gitlab.com/gromacs/gromacs/-/issues/4690)
  * CI tests: revert workaround for flaky tests, removed upstream.

 -- Nicholas Breen <nbreen@debian.org>  Fri, 19 Dec 2025 21:16:15 -0800

=== debian/control ===
Source: gromacs
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Nicholas Breen <nbreen@debian.org>
Build-Depends: architecture-is-64-bit,
               bash-completion,
               chrpath,
               cmake (>= 3.13),
               debhelper-compat (= 13),
               dh-python,
               libblas-dev,
               libboost-dev,
               libfftw3-dev,
               libhwloc-dev,
               liblapack-dev,
               libmuparser-dev (>= 2.3.4),
               lsb-release,
               mpi-default-bin,
               mpi-default-dev,
               pkgconf,
               python3-dev,
               python3-mpi4py,
               python3-networkx,
               python3-numpy,
               python3-pybind11,
               python3-pytest,
               zlib1g-dev
Build-Depends-Indep: doxygen,
                     furo,
                     ghostscript,
                     graphicsmagick,
                     graphviz,
                     mscgen,
                     python3-pygments,
                     python3-sphinx,
                     python3-sphinx-argparse,
                     python3-sphinx-copybutton,
                     python3-sphinx-inline-tabs,
                     python3-sphinxcontrib.autoprogram,
                     rdfind,
                     symlinks,
                     tex-gyre,
                     texlive-fonts-recommended,
                     texlive-latex-base,
                     texlive-latex-extra
Rules-Requires-Root: no
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debichem-team/gromacs
Vcs-Git: https://salsa.debian.org/debichem-team/gromacs.git
Homepage: https://www.gromacs.org/

Package: gromacs
Architecture: any
Depends: gromacs-data (= ${source:Version}),
         sse4.2-support [amd64],
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: gromacs-mpich (<< 2021.1-2), gromacs-openmpi (<< 2021.1-2), gromacs-mpi (<< 2022~)
Replaces: gromacs-mpich (<< 2021.1-2), gromacs-openmpi (<< 2021.1-2), gromacs-mpi (<< 2022~)
Recommends: cpp, mpi-default-bin
Suggests: pymol
Description: Molecular dynamics simulator, with building and analysis tools
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.
 .
 This package contains variants both for execution on a single machine, and
 using the MPI interface across multiple machines.

Package: gromacs-data
Architecture: all
Multi-Arch: foreign
Depends: libjs-mathjax, ${misc:Depends}
Recommends: gromacs
Description: GROMACS molecular dynamics sim, data and documentation
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.
 .
 This package contains architecture-independent topology and force field
 data, documentation, man pages, and example files.

Package: libgromacs11
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: GROMACS molecular dynamics sim, shared libraries
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.
 .
 This package contains the shared library, libgromacs.

Package: libgromacs-dev
Architecture: any
Section: libdevel
Depends: libfftw3-dev,
         libgromacs11 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: gromacs-data
Suggests: mpi-default-bin,
          mpi-default-dev,
          zlib1g-dev
Description: GROMACS molecular dynamics sim, development kit
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.
 .
 This package contains header files and static libraries for development
 purposes, plus sample Makefiles.  Development components for MPI-enabled
 GROMACS builds also require their respective packages.

Package: libnblib-gmx0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libgromacs6 (<< 2021~beta2-2)
Replaces: libgromacs6 (<< 2021~beta2-2)
Description: GROMACS molecular dynamics sim, NB-LIB shared libraries
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 The goal of NB-LIB is to enable researchers to programmatically define
 molecular simulations. Traditionally these have been performed using a
 collection of executables and a manual workflow followed by a “black-box”
 simulation engine. NB-LIB allows users to script a variety of novel
 simulation and analysis workflows at a more granular level.
 .
 This package contains the shared library, libnblib-gmx.

Package: libnblib-gmx-dev
Architecture: any
Section: libdevel
Depends: libnblib-gmx0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: libgromacs-dev (= ${binary:Version}),
Suggests: gromacs (= ${binary:Version})
Breaks: libgromacs-dev (<< 2021~beta2-2), libnblib-dev (<< 2022-1)
Replaces: libgromacs-dev (<< 2021~beta2-2), libnblib-dev (<< 2022-1)
Description: GROMACS molecular dynamics sim, NB-LIB development kit
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 The goal of NB-LIB is to enable researchers to programmatically define
 molecular simulations. Traditionally these have been performed using a
 collection of executables and a manual workflow followed by a “black-box”
 simulation engine. NB-LIB allows users to script a variety of novel
 simulation and analysis workflows at a more granular level.
 .
 This package contains header files for NB-LIB.  For the legacy GROMACS
 API, see libgromacs-dev.

=== debian/rules ===
#!/usr/bin/make -f
#
# build script for GROMACS

PACKAGE := gromacs

include /usr/share/dpkg/architecture.mk
DEB_DISTRO  ?= $(shell lsb_release -si)
DEB_VERSION ?= $(shell dpkg-parsechangelog -S version)

# add hardening flags, using dpkg-buildflags
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
#653916 and http://www.cmake.org/Bug/view.php?id=12928 and https://gitlab.kitware.com/cmake/cmake/-/issues/12928
CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

# General configuration options used for all builds.
COMMON_CONFIG_PARAMS = \
	$(CURDIR) \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_RULE_MESSAGES=OFF \
	-DCMAKE_INSTALL_PREFIX="/usr" \
	-DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" \
	-DCMAKE_SKIP_RPATH=ON \
	-DGMX_EXTERNAL_ZLIB=ON \
	-DGMX_USE_MUPARSER=EXTERNAL \
	-DGMX_VERSION_STRING_OF_FORK="$(DEB_DISTRO)-$(DEB_VERSION)" \
	-DGMX_GIT_VERSION_INFO=OFF \
	-DGMX_HWLOC=ON

# DEB_BUILD_OPTIONS boilerplate.
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g -Wall
	COMMON_CONFIG_PARAMS += -DCMAKE_BUILD_TYPE=Debug
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
	COMMON_CONFIG_PARAMS += -DCMAKE_BUILD_TYPE=Debug
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKE += -j$(NUMJOBS)
endif

# Specific options for the MPI-enabled builds.
MPI_CONFIG_PARAMS = \
	-DGMX_MPI=ON \
	-DMPIEXEC="/usr/bin/mpiexec"

# For compatibility reasons, disable SIMD CPU optimizations EXCEPT
# for SSE4.1 on amd64, and NEON on arm64.
# For local compilations, set DEB_BUILD_OPTIONS=cpuopt for automatic
# detection of the best available option.
# See https://manual.gromacs.org/documentation/current/user-guide/mdrun-performance.html#intra-core-parallelization
# and https://manual.gromacs.org/documentation/current/install-guide/index.html#gmx-simd-support
ifeq (,$(findstring cpuopt,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH), amd64)
	COMMON_CONFIG_PARAMS += -DGMX_SIMD=SSE4.1
else ifeq ($(DEB_HOST_ARCH), arm64)
	COMMON_CONFIG_PARAMS += -DGMX_SIMD=ARM_NEON_ASIMD
else
	COMMON_CONFIG_PARAMS += -DGMX_SIMD=None
endif
endif

# Include "gpu" in DEB_BUILD_OPTIONS to build GPU-accelerated binaries as well.
# This build option is not always well tested, please send comments.
# You must have the packages "nvidia-cuda-toolkit" and "nvidia-cuda-dev"
# installed. Those are not official build dependencies to keep the package in
# Debian main!
#
# If you use this option, it is strongly recommended that you also set
# DEB_BUILD_OPTIONS=cpuopt, assuming you are compiling and running on the same
# machine.
#
# Further details at
# https://manual.gromacs.org/documentation/current/user-guide/mdrun-performance.html#running-mdrun-with-gpus
GPU_CONFIG_PARAMS =
ifneq (,$(findstring gpu,$(DEB_BUILD_OPTIONS)))
	GPU_CONFIG_PARAMS += -DGMX_GPU=ON
endif

# Improve display of build-time tests.
export GTEST_COLOR=no
export CTEST_OUTPUT_ON_FAILURE=1

#######################################################################

build: build-arch build-indep

build-arch: configure-stamp build-basic build-mpi
build-indep: build-manual

configure: configure-stamp
configure-stamp:
	dh_testdir
	(mkdir -p build/basic; cd build/basic; cmake \
	$(COMMON_CONFIG_PARAMS) $(GPU_CONFIG_PARAMS) -DGMX_MPI=OFF -DGMX_INSTALL_LEGACY_API=ON)
	(mkdir -p build/basic-dp; cd build/basic-dp; cmake \
	$(COMMON_CONFIG_PARAMS) -DGMX_MPI=OFF -DGMX_DOUBLE=ON)
	(mkdir -p build/mpi; cd build/mpi; CC=/usr/bin/mpicc CXX=/usr/bin/mpicxx cmake \
	$(COMMON_CONFIG_PARAMS) $(MPI_CONFIG_PARAMS) $(GPU_CONFIG_PARAMS) -DGMXAPI=ON -DGMX_PYTHON_PACKAGE=ON)
	(mkdir -p build/mpi-dp; cd build/mpi-dp; CC=/usr/bin/mpicc CXX=/usr/bin/mpicxx cmake \
	$(COMMON_CONFIG_PARAMS) $(MPI_CONFIG_PARAMS) -DGMX_DOUBLE=ON)
	touch $@

# Standard builds, in single and double precision.
build-basic: configure-stamp
	dh_testdir
	$(MAKE) -C build/basic
	$(MAKE) -C build/basic-dp
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C build/basic tests
	(cd build/basic;    LD_LIBRARY_PATH=$(CURDIR)/build/basic/lib    ctest -V)
	$(MAKE) -C build/basic-dp tests
	(cd build/basic-dp; LD_LIBRARY_PATH=$(CURDIR)/build/basic-dp/lib ctest -V)
endif
	touch $@

# MPI-enabled builds.  Separated from the build-basic target mostly for ease of testing.
build-mpi: configure-stamp
	dh_testdir
	LD_LIBRARY_PATH=$(CURDIR)/build/mpi/lib $(MAKE) -C build/mpi
	$(MAKE) -C build/mpi-dp
# Testing the single precision build only is sufficient to exercise the MPI-specific tests.
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
# oversubscribe: https://bugs.debian.org/850229#51 (OMPI_... for OpenMPI <=4,
#                                                   PRTE_... for OpenMPI >=5)
# Applicable only to OpenMPI, but no-ops on MPICH architectures
	LD_LIBRARY_PATH=$(CURDIR)/build/mpi/lib $(MAKE) -C build/mpi tests
	(cd build/mpi ; LD_LIBRARY_PATH=$(CURDIR)/build/mpi/lib \
                        OMPI_MCA_rmaps_base_oversubscribe=1 \
                        PRTE_MCA_rmaps_default_mapping_policy=:oversubscribe \
                        ctest -V)
endif
	touch $@

# Documentation.
build-manual:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_testdir
# Build speedy, stripped-down version just for documentation generation.
# Derived from (former) admin/build-docs.sh
	(mkdir -p build/documentation ; cd build/documentation; \
	LD_LIBRARY_PATH=$(CURDIR)/build/documentation/lib cmake $(CURDIR) \
	-DCMAKE_BUILD_TYPE=Debug -DGMX_THREAD_MPI=OFF -DGMX_SIMD=None -DGMXAPI=ON \
	-DGMX_PYTHON_PACKAGE=ON -DGMX_GPU=OFF -DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_RULE_MESSAGES=OFF -DGMX_BUILD_MANUAL=ON -DGMX_BUILD_HELP=ON \
	-DCMAKE_DISABLE_FIND_PACKAGE_MPI=OFF -DGMX_USE_SIMD_KERNELS=OFF \
	-DGMX_VERSION_STRING_OF_FORK="$(DEB_DISTRO)-$(DEB_VERSION)")
# Generate PDF
	$(MAKE) manual -C build/documentation
# Generate man pages
	$(MAKE) man -C build/documentation
# Generate HTML
# 2025-12-18 downgraded from "webpage" to "doxygen-user" due to build errors
	$(MAKE) doxygen-user -C build/documentation
endif
	touch $@

# Rules in this target largely handle the executable and library packages and arch-indep data (but not documentation).
install: build-arch
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) -C build/mpi      install DESTDIR=$(CURDIR)/debian/tmp
	$(MAKE) -C build/mpi-dp   install DESTDIR=$(CURDIR)/debian/tmp
	$(MAKE) -C build/basic    install DESTDIR=$(CURDIR)/debian/tmp
	$(MAKE) -C build/basic-dp install DESTDIR=$(CURDIR)/debian/tmp

# workaround for OpenMPI 5.x RPATH bug, #1085509
	chrpath -d $(CURDIR)/debian/tmp/usr/bin/gmx_mpi $(CURDIR)/debian/tmp/usr/bin/gmx_mpi_d
	chrpath -d $(CURDIR)/debian/tmp/usr/lib/*/libgromacs_mpi*.so.*

# concatenate bash completions into a single file; not just "cat * >" because they don't end in newlines
	perl -lne 'print' $(CURDIR)/debian/tmp/usr/bin/gmx-completion.bash \
	                  $(CURDIR)/debian/tmp/usr/bin/gmx-completion-*.bash > \
	                  $(CURDIR)/debian/tmp/usr/bin/gmx-completion-concat

# rename a pair of Perl scripts to drop the .pl extension (Policy 10.4)
	mv $(CURDIR)/debian/tmp/usr/bin/demux.pl     $(CURDIR)/debian/tmp/usr/bin/demux
	mv $(CURDIR)/debian/tmp/usr/bin/xplor2gmx.pl $(CURDIR)/debian/tmp/usr/bin/xplor2gmx

	dh_install -a
	dh_installdocs -a
	dh_installchangelogs -a
	dh_installman -a
	dh_bash-completion -a
	dh_lintian -a
	dh_link -a

binary-indep: build-arch build-indep install
	dh_testdir -i
	dh_testroot -i
	dh_installdirs -i
	dh_install -i
	dh_installdocs -i
	dh_installchangelogs -i
	dh_installman -i
# dh_doxygen expects a different location of index.html, so perform its function manually.
	-find $(CURDIR)/debian/gromacs-data/usr/share/doc/gromacs/html/doxygen/ -type f -a \( -name '*.md5' -o -name '*.map' \) -delete
	rdfind -outputname /dev/null -makesymlinks true $(CURDIR)/debian/gromacs-data/usr/share/doc/
	symlinks -r -s -c $(CURDIR)/debian/gromacs-data/usr/share/doc/
